/* diversity-conn-man.h - DiversityConnMan
 *
 * Copyright 2008 OpenMoko, Inc.
 * Authored by Chia-I Wu <olv@openmoko.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _DIVERSITY_CONN_MAN_H_
#define _DIVERSITY_CONN_MAN_H_

#define G_DISABLE_CAST_CHECKS

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define DIVERSITY_TYPE_CONN_MAN			(diversity_conn_man_get_type())
#define DIVERSITY_CONN_MAN(obj)			(G_TYPE_CHECK_INSTANCE_CAST((obj), DIVERSITY_TYPE_CONN_MAN, DiversityConnMan))
#define DIVERSITY_CONN_MAN_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST((klass), DIVERSITY_TYPE_CONN_MAN, DiversityConnManClass))
#define DIVERSITY_IS_CONN_MAN(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), DIVERSITY_TYPE_CONN_MAN))
#define DIVERSITY_IS_CONN_MAN_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), DIVERSITY_TYPE_CONN_MAN))
#define DIVERSITY_CONN_MAN_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), DIVERSITY_TYPE_CONN_MAN, DiversityConnManClass))

typedef struct _DiversityConnMan DiversityConnMan;
typedef struct _DiversityConnManClass DiversityConnManClass;

typedef enum _DiversityConnManState DiversityConnManState;

enum _DiversityConnManState {
	DIVERSITY_CONN_MAN_STATE_OFFLINE,
	DIVERSITY_CONN_MAN_STATE_ONLINE
};

struct _DiversityConnMan {
	GObject parent_object;
};

struct _DiversityConnManClass {
	GObjectClass parent_class;

	void (*interface_added)(DiversityConnMan *cman, const gchar *objpath, gpointer user_data);
	void (*interface_removed)(DiversityConnMan *cman, const gchar *objpath, gpointer user_data);
};

GType diversity_conn_man_get_type(void) G_GNUC_CONST;

DiversityConnMan *diversity_conn_man_new(GError **error);

DiversityConnManState diversity_conn_man_get_state(DiversityConnMan *cman);
GSList *diversity_conn_man_list_interfaces(DiversityConnMan *cman);

G_END_DECLS

#endif /* _DIVERSITY_CONN_MAN_H_ */
