/* diversity-nm.h - DiversityNm
 *
 * Copyright 2008 OpenMoko, Inc.
 * Authored by Chia-I Wu <olv@openmoko.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _DIVERSITY_NM_H_
#define _DIVERSITY_NM_H_

#define G_DISABLE_CAST_CHECKS

#include <glib.h>
#include <diversity-equipment.h>

G_BEGIN_DECLS

#define DIVERSITY_TYPE_NM		(diversity_nm_get_type())
#define DIVERSITY_NM(obj)		(G_TYPE_CHECK_INSTANCE_CAST((obj), DIVERSITY_TYPE_NM, DiversityNm))
#define DIVERSITY_NM_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), DIVERSITY_TYPE_NM, DiversityNmClass))
#define DIVERSITY_IS_NM(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), DIVERSITY_TYPE_NM))
#define DIVERSITY_IS_NM_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), DIVERSITY_TYPE_NM))
#define DIVERSITY_NM_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), DIVERSITY_TYPE_NM, DiversityNmClass))

typedef struct _DiversityNm DiversityNm;
typedef struct _DiversityNmClass DiversityNmClass;

struct _DiversityNm {
	DiversityEquipment parent_object;
};

struct _DiversityNmClass {
	DiversityEquipmentClass parent_class;

	void (*ap_added)(DiversityNm *nm, GSList *aps, gpointer user_data);
	void (*ap_removed)(DiversityNm *nm, GSList *aps, gpointer user_data);
};

GType diversity_nm_get_type(void) G_GNUC_CONST;

DiversityNm *diversity_nm_new(void);

const GSList *diversity_nm_list_aps(DiversityNm *nm);

void diversity_nm_set_scan_interval(DiversityNm *nm, guint interval);
guint diversity_nm_get_scan_interval(DiversityNm *nm);

void diversity_nm_set_interface(DiversityNm *nm, const gchar *iface);
const gchar *diversity_nm_get_interface(DiversityNm *nm);

void diversity_nm_set_state(DiversityNm *nm, guint state);
guint diversity_nm_get_state(DiversityNm *nm);

void diversity_nm_set_ip4_address(DiversityNm *nm, guint address);
guint diversity_nm_get_ip4_address(DiversityNm *nm);

G_END_DECLS

#endif /* _DIVERSITY_NM_H_ */
