/* diversity-curl.h - DiversityCurl
 *
 * Copyright 2008 OpenMoko, Inc.
 * Authored by Chia-I Wu <olv@openmoko.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _DIVERSITY_CURL_H_
#define _DIVERSITY_CURL_H_

#define G_DISABLE_CAST_CHECKS

#include <glib.h>

G_BEGIN_DECLS

#define DIVERSITY_TYPE_CURL		(diversity_curl_get_type())
#define DIVERSITY_CURL(obj)		(G_TYPE_CHECK_INSTANCE_CAST((obj), DIVERSITY_TYPE_CURL, DiversityCurl))
#define DIVERSITY_CURL_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), DIVERSITY_TYPE_CURL, DiversityCurlClass))
#define DIVERSITY_IS_CURL(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), DIVERSITY_TYPE_CURL))
#define DIVERSITY_IS_CURL_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), DIVERSITY_TYPE_CURL))
#define DIVERSITY_CURL_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), DIVERSITY_TYPE_CURL, DiversityCurlClass))

typedef struct _DiversityCurl DiversityCurl;
typedef struct _DiversityCurlClass DiversityCurlClass;

typedef struct _DiversityCurlJob DiversityCurlJob;

struct _DiversityCurlJob {
	gchar *uri;
	gchar *path;

	DiversityAtlasTileStatus status;
};

struct _DiversityCurl {
	GObject parent_object;
};

struct _DiversityCurlClass {
	GObjectClass parent_class;

	void (*job_completed)(DiversityCurl *curl, DiversityCurlJob *job);
};

GType diversity_curl_get_type(void) G_GNUC_CONST;

DiversityCurl *diversity_curl_new(gint pool_size, gint queue_size);

DiversityCurlJob *diversity_curl_job_get(DiversityCurl *curl);
void diversity_curl_job_submit(DiversityCurl *curl, DiversityCurlJob *job);
void diversity_curl_job_cancel(DiversityCurl *curl, DiversityCurlJob *job);

G_END_DECLS

#endif /* _DIVERSITY_CURL_H_ */
