/* diversity-qtopia-contacts.h - DiversityQtopiaContacts
 *
 * Copyright 2008 OpenMoko, Inc.
 * Authored by Chia-I Wu <olv@openmoko.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _DIVERSITY_QTOPIA_CONTACTS_H_
#define _DIVERSITY_QTOPIA_CONTACTS_H_

#define G_DISABLE_CAST_CHECKS

#include <glib-object.h>
#include <glib.h>

G_BEGIN_DECLS

#define DIVERSITY_TYPE_QTOPIA_CONTACTS			(diversity_qtopia_contacts_get_type())
#define DIVERSITY_QTOPIA_CONTACTS(obj)			(G_TYPE_CHECK_INSTANCE_CAST((obj), DIVERSITY_TYPE_QTOPIA_CONTACTS, DiversityQtopiaContacts))
#define DIVERSITY_QTOPIA_CONTACTS_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST((klass), DIVERSITY_TYPE_QTOPIA_CONTACTS, DiversityQtopiaContactsClass))
#define DIVERSITY_IS_QTOPIA_CONTACTS(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), DIVERSITY_TYPE_QTOPIA_CONTACTS))
#define DIVERSITY_IS_QTOPIA_CONTACTS_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), DIVERSITY_TYPE_QTOPIA_CONTACTS))
#define DIVERSITY_QTOPIA_CONTACTS_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), DIVERSITY_TYPE_QTOPIA_CONTACTS, DiversityQtopiaContactsClass))

typedef struct _DiversityQtopiaContacts DiversityQtopiaContacts;
typedef struct _DiversityQtopiaContactsClass DiversityQtopiaContactsClass;

struct _DiversityQtopiaContacts {
	GObject parent_object;
};

struct _DiversityQtopiaContactsClass {
	GObjectClass parent_class;

	void (*contacts_added)(DiversityQtopiaContacts *qcontacts, GList *contacts, gpointer user_data);
	void (*contacts_changed)(DiversityQtopiaContacts *qcontacts, GList *contacts, gpointer user_data);
	void (*contacts_removed)(DiversityQtopiaContacts *qcontacts, GList *uids, gpointer user_data);
};

typedef struct _DiversityQtopiaContact DiversityQtopiaContact;

struct _DiversityQtopiaContact {
	gchar *uid;
	gchar *fullname;
	gchar *phone;
};

GType diversity_qtopia_contacts_get_type(void) G_GNUC_CONST;

DiversityQtopiaContacts *diversity_qtopia_contacts_new(void);

gboolean diversity_qtopia_contacts_open_and_start(DiversityQtopiaContacts *qcontacts);

G_END_DECLS

#endif /* _DIVERSITY_QTOPIA_CONTACTS_H_ */
