/* diversity-qtopia-sms.h - DiversityQtopiaSms
 *
 * Copyright 2008 OpenMoko, Inc.
 * Authored by Chia-I Wu <olv@openmoko.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _DIVERSITY_QTOPIA_SMS_H_
#define _DIVERSITY_QTOPIA_SMS_H_

#define G_DISABLE_CAST_CHECKS

#include <glib.h>
#include <diversity-equipment.h>
#include <diversity-sms.h>

G_BEGIN_DECLS

#define DIVERSITY_TYPE_QTOPIA_SMS		(diversity_qtopia_sms_get_type())
#define DIVERSITY_QTOPIA_SMS(obj)		(G_TYPE_CHECK_INSTANCE_CAST((obj), DIVERSITY_TYPE_QTOPIA_SMS, DiversityQtopiaSms))
#define DIVERSITY_QTOPIA_SMS_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), DIVERSITY_TYPE_QTOPIA_SMS, DiversityQtopiaSmsClass))
#define DIVERSITY_IS_QTOPIA_SMS(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), DIVERSITY_TYPE_QTOPIA_SMS))
#define DIVERSITY_IS_QTOPIA_SMS_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), DIVERSITY_TYPE_QTOPIA_SMS))
#define DIVERSITY_QTOPIA_SMS_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), DIVERSITY_TYPE_QTOPIA_SMS, DiversityQtopiaSmsClass))

typedef struct _DiversityQtopiaSms DiversityQtopiaSms;
typedef struct _DiversityQtopiaSmsClass DiversityQtopiaSmsClass;

struct _DiversityQtopiaSms {
	DiversityEquipment parent_object;
};

struct _DiversityQtopiaSmsClass {
	DiversityEquipmentClass parent_class;

	void (*tag_added)(DiversityQtopiaSms *qsms, const gchar *uid, gdouble lon, gdouble lat, const gchar *desc);
};

GType diversity_qtopia_sms_get_type(void) G_GNUC_CONST;

DiversityQtopiaSms *diversity_qtopia_sms_new(const gchar *name);

gboolean diversity_qtopia_sms_open_and_start(DiversityQtopiaSms *qsms);

gboolean diversity_qtopia_sms_remove(DiversityQtopiaSms *qsms, const gchar *uid);

G_END_DECLS

#endif /* _DIVERSITY_QTOPIA_SMS_H_ */
