/* xmpp-caps.h - XMPP Entity Capabilities support
 *
 * Copyright 2008 OpenMoko, Inc.
 * Authored by Daniel Willmann <daniel@openmoko.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _XMPP_CAPS_H_
#define _XMPP_CAPS_H_

#define G_DISABLE_CAST_CHECKS

#include <glib.h>
#include <diversity-xmpp.h>
#include <xmpp-disco.h>
#include <xmpp-discoinfo.h>

G_BEGIN_DECLS

#define XMPP_NS_CAPS "http://jabber.org/protocol/caps"

#define XMPP_TYPE_CAPS		(xmpp_caps_get_type())
#define XMPP_CAPS(obj)		(G_TYPE_CHECK_INSTANCE_CAST((obj), XMPP_TYPE_CAPS, XmppCaps))
#define XMPP_CAPS_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), XMPP_TYPE_CAPS, XmppCapsClass))
#define XMPP_IS_CAPS(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), XMPP_TYPE_CAPS))
#define XMPP_IS_CAPS_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), XMPP_TYPE_CAPS))
#define XMPP_CAPS_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), XMPP_TYPE_CAPS, XmppCapsClass))

typedef struct _XmppCaps XmppCaps;
typedef struct _XmppCapsClass XmppCapsClass;

struct _XmppCaps {
	GObject parent_object;
};

struct _XmppCapsClass {
	GObjectClass parent_class;
};

GType xmpp_caps_get_type(void) G_GNUC_CONST;

XmppCaps *xmpp_caps_new(DiversityXmpp *xmpp, XmppDisco *disco, GError **error);


XmppDiscoinfo *xmpp_caps_get_discoinfo(XmppCaps *caps, const gchar *hash, const gchar *hash_func);
void xmpp_caps_add_c_node(XmppCaps *caps, LmMessageNode *node);

G_END_DECLS

#endif /* _XMPP_CAPS_H_ */
