/* diversity-tag.h - DiversityTag
 *
 * Copyright 2008 OpenMoko, Inc.
 * Authored by Chia-I Wu <olv@openmoko.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _DIVERSITY_TAG_H_
#define _DIVERSITY_TAG_H_

#define G_DISABLE_CAST_CHECKS

#include <glib.h>
#include <glib-object.h>
#include <diversity-object.h>

G_BEGIN_DECLS

#define DIVERSITY_TAG_DESCRIPTION	"description"

#define DIVERSITY_TYPE_TAG		(diversity_tag_get_type())
#define DIVERSITY_TAG(obj)		(G_TYPE_CHECK_INSTANCE_CAST((obj), DIVERSITY_TYPE_TAG, DiversityTag))
#define DIVERSITY_TAG_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), DIVERSITY_TYPE_TAG, DiversityTagClass))
#define DIVERSITY_IS_TAG(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), DIVERSITY_TYPE_TAG))
#define DIVERSITY_IS_TAG_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), DIVERSITY_TYPE_TAG))
#define DIVERSITY_TAG_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), DIVERSITY_TYPE_TAG, DiversityTagClass))

typedef struct _DiversityTag DiversityTag;
typedef struct _DiversityTagClass DiversityTagClass;

struct _DiversityTag {
	DiversityObject parent_object;
};

struct _DiversityTagClass {
	DiversityObjectClass parent_class;

	void (*modified)(DiversityTag *tag, const gchar *key, const gchar *val);
};

GType diversity_tag_get_type(void) G_GNUC_CONST;

DiversityTag *diversity_tag_new(void);

void diversity_tag_set(DiversityTag *tag, const gchar *key, const gchar *val);
const gchar *diversity_tag_get(DiversityTag *tag, const gchar *key);
void diversity_tag_foreach(DiversityTag *tag, GHFunc func, gpointer user_data);

const GHashTable *diversity_tag_get_hash_table(DiversityTag *tag);

void diversity_tag_set_unread(DiversityTag *tag, gboolean unread);
gboolean diversity_tag_get_unread(DiversityTag *tag);

GTime diversity_tag_get_created(DiversityTag *tag);

G_END_DECLS

#endif /* _DIVERSITY_TAG_H_ */
